/*Copyright (C) 2010 Deveaux Duncan

This file is part of Hikou no mizu.

Hikou no mizu is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

Hikou no mizu is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with Hikou no mizu.  If not, see <http://www.gnu.org/licenses/>.
*/

#include <stdio.h>
#include <SFML/Graphics.hpp>
#include "Joueur/Joueur.hpp"
#include "Moteurs/MoteurImage.hpp"
#include "Moteurs/MoteurGraphique.hpp"

int main()
{
	sf::RenderWindow fenetre(sf::VideoMode(1000, 600, 32), "Hikou no mizu");
	sf::Image iconeFenetre;
	iconeFenetre.LoadFromFile("icone.png");
	fenetre.SetIcon(iconeFenetre.GetWidth(), iconeFenetre.GetHeight(), iconeFenetre.GetPixelsPtr());
	fenetre.UseVerticalSync(true);
	//fenetre.SetFramerateLimit(60);
	
	/*GestionnaireImage *test = GestionnaireImage::recupereInstance();
	
	sf::Image *testImage = test->recupereImage("icone.png");
	sf::Image *testImage2 = test->recupereImage("icone.png");*/
	
	
	sf::Image fond;
	fond.LoadFromFile("fond.png");
	fond.SetSmooth(false);
		
	sf::Text texte("Hikou no mizu", sf::Font::GetDefaultFont(), 45);
	texte.SetColor(sf::Color(255, 255, 255, 50));
	
	sf::Sprite afficheFond;
	afficheFond.SetImage(fond);
	
	MoteurGraphique moteur(&fenetre);
	moteur.ajouteObjet(&afficheFond);
	
	Joueur joueur1("Takino", 100, 100, 5, 8);
	joueur1.setSens(1);
	joueur1.setPositionX(150);
	joueur1.setPositionY(350);
	
	Joueur joueur2("Hikou", 5, 5, 3, 5);
	joueur2.setPositionX(850);
	joueur2.setPositionY(350);
	
	joueur1.setJoueurAdverse(&joueur2);
	joueur2.setJoueurAdverse(&joueur1);
	
	joueur1.demarreAffichage(moteur);
	joueur2.demarreAffichage(moteur);
	moteur.ajouteObjet(&texte);
	
	while(fenetre.IsOpened())
	{
		sf::Event evenement;
		while (fenetre.GetEvent(evenement))
		{
			if (evenement.Type == sf::Event::Closed)
				fenetre.Close();
		}
		if (fenetre.GetInput().IsKeyDown(sf::Key::N)) texte.Move(5, 3);
		else if (fenetre.GetInput().IsKeyDown(sf::Key::B)) texte.Move(-5, -3);
		
		if (fenetre.GetInput().IsKeyDown(sf::Key::V)) moteur.supprimeObjet(&afficheFond);
		joueur1.executeActions(fenetre.GetInput());
		joueur2.executeActions(fenetre.GetInput());
		
		
		fenetre.Clear();
		moteur.afficheRendu();
		fenetre.Display();
	}
	
	return EXIT_SUCCESS;
}
